//
//  Header.m
//  我的下拉刷新
//
//  Created by ly on 16/9/30.
//  Copyright © 2016年 ZST. All rights reserved.
//

#import "Header.h"
#import "MBProgressHUD.h"
@implementation Header

+ (instancetype)initWithDoingSomething :(doingSomething )doingSomething {
    Header * header = [[Header  alloc] initWithFrame:CGRectMake(0, -200, Screen_Weidth, 200)];
    header.backgroundColor = [[UIColor grayColor] colorWithAlphaComponent:0.2] ;
    header.doingSomething = doingSomething;
    header.textLabel = [[UILabel alloc]initWithFrame:CGRectMake(0, 150, Screen_Weidth, 50)];
    header.textLabel.textAlignment = NSTextAlignmentCenter ;
    header.textLabel.textColor = [UIColor blackColor];
    header.textLabel.font = [UIFont  systemFontOfSize:12] ;
    [header addSubview: header.textLabel ];
    
    return header ;
}
- (void)setScrollView:(UIScrollView *)scrollView {
    _scrollView = scrollView ;
    [_scrollView addSubview: self ] ;
    [_scrollView addObserver:self forKeyPath:@"contentOffset" options:NSKeyValueObservingOptionNew context:nil] ;
}

- (void)observeValueForKeyPath:(NSString *)keyPath ofObject:(id)object change:(NSDictionary<NSKeyValueChangeKey,id> *)change context:(void *)context {
    
    if ([keyPath isEqualToString:@"contentOffset"] == NO || self.isReload == YES) {
        return ;
    }
    NSLog(@"change  -- %@",change) ;
    CGPoint newPoint = [change[@"new"] CGPointValue] ;
    if (newPoint.y < - 50) {
        if (self.scrollView.isDragging) {
            self.textLabel.text =  @"⇡ 松开即可刷新" ;
            return ;
        }
        if (self.isReload == NO) {
            [self beginAnimation] ;
        }
    }else if (newPoint.y > -50 && newPoint.y < 0){
        self.textLabel.text = @"⇣ 继续下拉刷新" ;
    }else {
        self.isReload = NO;
    }
    
}


- (void) beginAnimation {
    if (self.isReload == YES) {
        return ;
    }
    self.isReload = YES ;
    self.textLabel.text = @"正在加载中..." ;
    [self showLoadingWithMessage:nil];
    [self.scrollView setContentOffset:CGPointMake(0, -50) animated:YES ];
    self.doingSomething();
}


- (void) endAnimation {
    self.isReload = NO ;
    self.textLabel.text = @"加载完成" ;
    [UIView animateWithDuration:0.2 animations:^{
        self.scrollView.contentOffset = CGPointZero ;
        [MBProgressHUD hideAllHUDsForView:self.scrollView animated:YES];
    }];
    
}

- (void)showLoadingWithMessage:(NSString *)message {
    if (message==nil || [message isEqualToString:@""]) {
        message = @"加载中..." ;
    }
    MBProgressHUD *hud = [MBProgressHUD showHUDAddedTo:self.scrollView animated:YES];
    hud.labelText = message;
    [hud show:YES];
}




@end
